
-- not just the keyboard, but also the mouse and joystick binder as well.

function cbPopVKeyboard(curbind,profile)

local bindtext = iup.label{title=curbind.bind;rastersize="140x"}
local binddesc = iup.label{title=cbGetDesc(profile,curbind.bind);rastersize="140x"}

function kbAction(key) return function() cbSetBind(key,curbind) bindtext.title = curbind.bind binddesc.title = cbGetDesc(profile,curbind.bind) end end

local keyEsc = iup.button{title = "Esc";size = "20x"} keyEsc.action=kbAction("esc")
local fil1_1 = iup.fill{size = "20x"}
local keyF1 = iup.button{title = "F1";size = "20x"} keyF1.action=kbAction("F1")
local keyF2 = iup.button{title = "F2";size = "20x"} keyF2.action=kbAction("F2")
local keyF3 = iup.button{title = "F3";size = "20x"} keyF3.action=kbAction("F3")
local keyF4 = iup.button{title = "F4";size = "20x"} keyF4.action=kbAction("F4")
local fil1_2 = iup.fill{size = "10x"}
local keyF5 = iup.button{title = "F5";size = "20x"} keyF5.action=kbAction("F5")
local keyF6 = iup.button{title = "F6";size = "20x"} keyF6.action=kbAction("F6")
local keyF7 = iup.button{title = "F7";size = "20x"} keyF7.action=kbAction("F7")
local keyF8 = iup.button{title = "F8";size = "20x"} keyF8.action=kbAction("F8")
local fil1_3 = iup.fill{size = "11x"}
local keyF9 = iup.button{title = "F9";size = "20x"} keyF9.action=kbAction("F9")
local keyF10 = iup.button{title = "F10";size = "20x"} keyF10.action=kbAction("F10")
local keyF11 = iup.button{title = "F11";size = "20x"} keyF11.action=kbAction("F11")
local keyF12 = iup.button{title = "F12";size = "20x"} keyF12.action=kbAction("F12")

local line1 = iup.hbox{keyEsc;fil1_1;keyF1;keyF2;keyF3;keyF4;fil1_2;keyF5;keyF6;keyF7;keyF8;fil1_3;keyF9;keyF10;keyF11;keyF12;GAP="0"}

local line1_5 = iup.label{title = " ";size = "x10"; expand = "NO"}

local keyTilde = iup.button{title = "~";size = "20x"} keyTilde.action=kbAction("tilde")
local key1 = iup.button{title = "1";size = "20x"} key1.action=kbAction("1")
local key2 = iup.button{title = "2";size = "20x"} key2.action=kbAction("2")
local key3 = iup.button{title = "3";size = "20x"} key3.action=kbAction("3")
local key4 = iup.button{title = "4";size = "20x"} key4.action=kbAction("4")
local key5 = iup.button{title = "5";size = "20x"} key5.action=kbAction("5")
local key6 = iup.button{title = "6";size = "20x"} key6.action=kbAction("6")
local key7 = iup.button{title = "7";size = "20x"} key7.action=kbAction("7")
local key8 = iup.button{title = "8";size = "20x"} key8.action=kbAction("8")
local key9 = iup.button{title = "9";size = "20x"} key9.action=kbAction("9")
local key0 = iup.button{title = "0";size = "20x"} key0.action=kbAction("0")
local keyDash = iup.button{title = "-";size = "20x"} keyDash.action=kbAction("-")
local keyEquals = iup.button{title = "=";size = "20x"} keyEquals.action=kbAction("=")
local keyBackspace = iup.button{title = "<--";size = "40x"} keyBackspace.action=kbAction("backspace")
local fil2_1 = iup.fill{size = "10x"}
local keyInsert = iup.button{title = "Ins";size = "20x"} keyInsert.action=kbAction("insert")
local keyHome = iup.button{title = "Hom";size = "20x"} keyHome.action=kbAction("home")
local keyPageUp = iup.button{title = "PgUp";size = "20x"} keyPageUp.action=kbAction("pageup")
local fil2_2 = iup.fill{size = "11x"}
local keyNumLock = iup.button{title = "NmLk";size = "20x"} keyNumLock.action=kbAction("numlock")
local keyKPSlash = iup.button{title = "/";size = "20x"} keyKPSlash.action=kbAction("divide")
local keyKPStar = iup.button{title = "*";size = "20x"} keyKPStar.action=kbAction("multiply")
local keyKPMinus = iup.button{title = "-";size = "20x"} keyKPMinus.action=kbAction("subtract")

local line2 = iup.hbox{keyTilde;key1;key2;key3;key4;key5;key6;key7;key8;key9;key0;keyDash;keyEquals;keyBackspace;fil2_1;keyInsert;keyHome;keyPageUp;fil2_2;keyNumLock;keyKPSlash;keyKPStar;keyKPMinus;GAP="0"}

local keyTab = iup.button{title = "Tab";size = "30x"} keyTab.action=kbAction("tab")
local keyQ = iup.button{title = "Q";size = "20x"} keyQ.action=kbAction("Q")
local keyW = iup.button{title = "W";size = "20x"} keyW.action=kbAction("W")
local keyE = iup.button{title = "E";size = "20x"} keyE.action=kbAction("E")
local keyR = iup.button{title = "R";size = "20x"} keyR.action=kbAction("R")
local keyT = iup.button{title = "T";size = "20x"} keyT.action=kbAction("T")
local keyY = iup.button{title = "Y";size = "20x"} keyY.action=kbAction("Y")
local keyU = iup.button{title = "U";size = "20x"} keyU.action=kbAction("U")
local keyI = iup.button{title = "I";size = "20x"} keyI.action=kbAction("I")
local keyO = iup.button{title = "O";size = "20x"} keyO.action=kbAction("O")
local keyP = iup.button{title = "P";size = "20x"} keyP.action=kbAction("P")
local keyLeftBracket = iup.button{title = "[";size = "20x"} keyLeftBracket.action=kbAction("[")
local keyRightBracket = iup.button{title = "]";size = "20x"} keyRightBracket.action=kbAction("]")
local keyBackslash = iup.button{title = "\\";size = "31x"} keyBackslash.action=kbAction("\\")
local fil3_1 = iup.fill{size = "10x"}
local keyDelete = iup.button{title = "Del";size = "20x"} keyDelete.action=kbAction("delete")
local keyEnd = iup.button{title = "End";size = "20x"} keyEnd.action=kbAction("end")
local keyPageDn = iup.button{title = "PgDn";size = "20x"} keyPageDn.action=kbAction("pagedown")
local fil3_2 = iup.fill{size = "11x"}
local keyKP7 = iup.button{title = "7";size = "20x"} keyKP7.action=kbAction("numpad7")
local keyKP8 = iup.button{title = "8";size = "20x"} keyKP8.action=kbAction("numpad8")
local keyKP9 = iup.button{title = "9";size = "20x"} keyKP9.action=kbAction("numpad9")

local line3 = iup.hbox{keyTab;keyQ;keyW;keyE;keyR;keyT;keyY;keyU;keyI;keyO;keyP;keyLeftBracket;keyRightBracket;keyBackslash;fil3_1;keyDelete;keyEnd;keyPageDn;fil3_2;keyKP7;keyKP8;keyKP9;GAP="0"}

local keyCapsLock = iup.button{title = "CapsLk";size = "35x"} keyCapsLock.action=kbAction("capital")
local keyA = iup.button{title = "A";size = "20x"} keyA.action=kbAction("A")
local keyS = iup.button{title = "S";size = "20x"} keyS.action=kbAction("S")
local keyD = iup.button{title = "D";size = "20x"} keyD.action=kbAction("D")
local keyF = iup.button{title = "F";size = "20x"} keyF.action=kbAction("F")
local keyG = iup.button{title = "G";size = "20x"} keyG.action=kbAction("G")
local keyH = iup.button{title = "H";size = "20x"} keyH.action=kbAction("H")
local keyJ = iup.button{title = "J";size = "20x"} keyJ.action=kbAction("J")
local keyK = iup.button{title = "K";size = "20x"} keyK.action=kbAction("K")
local keyL = iup.button{title = "L";size = "20x"} keyL.action=kbAction("L")
local keySemicolon = iup.button{title = ";";size = "20x"} keySemicolon.action=kbAction(";")
local keyQuote = iup.button{title = "'";size = "20x"} keyQuote.action=kbAction("'")
local keyEnter = iup.button{title = "Enter";size = "46x"} keyEnter.action=kbAction("enter")
local fil4_1 = iup.fill{size = "80x"}
local keyKP4 = iup.button{title = "4";size = "20x"} keyKP4.action=kbAction("numpad4")
local keyKP5 = iup.button{title = "5";size = "20x"} keyKP5.action=kbAction("numpad5")
local keyKP6 = iup.button{title = "6";size = "20x"} keyKP6.action=kbAction("numpad6")

local line4 = iup.hbox{keyCapsLock;keyA;keyS;keyD;keyF;keyG;keyH;keyJ;keyK;keyL;keySemicolon;keyQuote;keyEnter;fil4_1;keyKP4;keyKP5;keyKP6;GAP="0"}

local keyKPPlus = iup.button{title = "+";size = "20x32"} keyKPPlus.action=kbAction("add")

local line34 = iup.hbox{iup.vbox{line3;line4;GAP="0"};keyKPPlus;GAP="0"}

local keyLShift = iup.button{title = "Shift";size = "45x"} keyLShift.action=kbAction("lshift")
local keyZ = iup.button{title = "Z";size = "20x"} keyZ.action=kbAction("Z")
local keyX = iup.button{title = "X";size = "20x"} keyX.action=kbAction("X")
local keyC = iup.button{title = "C";size = "20x"} keyC.action=kbAction("C")
local keyV = iup.button{title = "V";size = "20x"} keyV.action=kbAction("V")
local keyB = iup.button{title = "B";size = "20x"} keyB.action=kbAction("B")
local keyN = iup.button{title = "N";size = "20x"} keyN.action=kbAction("N")
local keyM = iup.button{title = "M";size = "20x"} keyM.action=kbAction("M")
local keyComma = iup.button{title = ",";size = "20x"} keyComma.action=kbAction(",")
local keyPeriod = iup.button{title = ".";size = "20x"} keyPeriod.action=kbAction(".")
local keySlash = iup.button{title = "/";size = "21x"} keySlash.action=kbAction("/")
local keyRShift = iup.button{title = "Shift";size = "55x"} keyRShift.action=kbAction("rshift")
local fil5_1 = iup.fill{size = "30x"}
local keyUp = iup.button{title = "Up";size = "20x"} keyUp.action=kbAction("up")
local fil5_2 = iup.fill{size = "31x"}
local keyKP1 = iup.button{title = "1";size = "20x"} keyKP1.action=kbAction("numpad1")
local keyKP2 = iup.button{title = "2";size = "20x"} keyKP2.action=kbAction("numpad2")
local keyKP3 = iup.button{title = "3";size = "20x"} keyKP3.action=kbAction("numpad3")

local line5 = iup.hbox{keyLShift;keyZ;keyX;keyC;keyV;keyB;keyN;keyM;keyComma;keyPeriod;keySlash;keyRShift;fil5_1;keyUp;fil5_2;keyKP1;keyKP2;keyKP3;GAP="0"}

local keyLCtrl = iup.button{title = "Ctrl";size = "40x"} keyLCtrl.action=kbAction("lctrl")
local keyLAlt = iup.button{title = "Alt";size = "40x"} keyLAlt.action=kbAction("lalt")
local keySpace = iup.button{title = " ";size = "140x"} keySpace.action=kbAction("space")
local keyRAlt = iup.button{title = "Alt";size = "40x"} keyRAlt.action=kbAction("ralt")
local keyRCtrl = iup.button{title = "Ctrl";size = "40x"} keyRCtrl.action=kbAction("rctrl")
local fil6_1 = iup.fill{size = "10x"}
local keyLeft = iup.button{title = "Lf";size = "20x"} keyLeft.action=kbAction("left")
local keyDown = iup.button{title = "Dn";size = "20x"} keyDown.action=kbAction("down")
local keyRight = iup.button{title = "Rt";size = "20x"} keyRight.action=kbAction("right")
local fil6_2 = iup.fill{size = "11x"}
local keyKP0 = iup.button{title = "0";size = "40x"} keyKP0.action=kbAction("numpad0")
local keyKPPeriod = iup.button{title = ".";size = "20x"} keyKPPeriod.action=kbAction("decimal")

local line6 = iup.hbox{keyLCtrl;keyLAlt;keySpace;keyRAlt;keyRCtrl;fil6_1;keyLeft;keyDown;keyRight;fil6_2;keyKP0;keyKPPeriod;GAP="0"}

local keyKPEnter = iup.button{title = "Ret";size = "20x32"} keyKPEnter.action=kbAction("numpadenter")

local line56 = iup.hbox{iup.vbox{line5;line6;GAP="0"};keyKPEnter;GAP="0"}

local bind = iup.button{title="Set Bind";size="50x"}
local cancel = iup.button{title="Cancel";size="50x"}

local bindinfo = iup.hbox{iup.fill{size="10x"};iup.vbox{bindtext;binddesc};iup.fill{};bind;cancel}

local msLeft = iup.button{title = "Left Mouse Btn";size = "80x"} msLeft.action=kbAction("lbutton")
local msRight = iup.button{title = "Right Mouse Btn";size = "80x"} msRight.action=kbAction("rbutton")
local msMid = iup.button{title = "Middle Mouse Btn";size = "80x"} msMid.action=kbAction("mbutton")
local msBtn4 = iup.button{title = "Fourth Mouse Btn";size = "80x"} msBtn4.action=kbAction("button4")
local msBtn5 = iup.button{title = "Fifth Mouse Btn";size = "80x"} msBtn5.action=kbAction("button5")
local msBtn6 = iup.button{title = "Sixth Mouse Btn";size = "80x"} msBtn6.action=kbAction("button6")
local msBtn7 = iup.button{title = "Seventh Mouse Btn";size = "80x"} msBtn7.action=kbAction("button7")
local msBtn8 = iup.button{title = "Eighth Mouse Btn";size = "80x"} msBtn8.action=kbAction("button8")

local mouse = iup.vbox{iup.fill{};msLeft;msRight;msMid;msBtn4;msBtn5;msBtn6;msBtn7;msBtn8;iup.fill{}}

local keys = iup.hbox{iup.vbox{line1;line1_5;line2;line34;line56};mouse}

local keyboard = iup.dialog{iup.vbox{keys;iup.fill{size="10"};bindinfo}; title="Keyboard"}

bind.action = function() keyboard:hide() end
cancel.action = function() curbind = nil keyboard:hide() end

--keyboard:showxy(iup.CENTER,iup.CENTER)
keyboard:popup(iup.CENTER,iup.CENTER)

return curbind

end