; Section define/macro header file
; See this header file for more info

!include "Sections.nsh"

;--------------------------------

Name "CityBinder v.0.4b"
OutFile "CityBinder0_4b.exe"

VIProductVersion "0.4.2.0"

SetCompressor /SOLID lzma

;--------------------------------

; Pages

Page license
Page directory
Page components
Page instfiles

LicenseData gpl.txt

InstallDir "$PROGRAMFILES\CityBinder"

;--------------------------------

; Sections

Section !Required
  SectionIn RO
  SetOutPath $INSTDIR
  Delete $INSTDIR\iuplua5.exe
  Delete $INSTDIR\citybinder.lua
  Delete $INSTDIR\cbutility.lua
  Delete $INSTDIR\speedondemand.lua
  Delete $INSTDIR\mastermind.lua
  Delete $INSTDIR\inspirationpopper.lua
  Delete $INSTDIR\typingmsg.lua
  Delete $INSTDIR\FPSDisplay.lua
  Delete $INSTDIR\simplebinds.lua
  Delete $INSTDIR\complexbinds.lua
  Delete "$SMPROGRAMS\CityBinder\CityBinder v.0.1.lnk"
  Delete "$SMPROGRAMS\CityBinder\CityBinder v.0.2.lnk"
  Delete "$DESKTOP\CityBinder v.0.1.lnk"
  Delete "$INSTDIR\CityBinder v.0.2.lnk"

  File iuplua5.exe
  File citybinder.lua
  File cbutility.lua
  File speedondemand.lua
  File mastermind.lua
  File inspirationpopper.lua
  File typingmsg.lua
  File FPSDisplay.lua
  File simplebinds.lua
  File complexbinds.lua
  File Example.cbp
  File default.lua
  File cbkeyboard.lua
  CreateDirectory "$SMPROGRAMS\CityBinder"
  CreateShortCut "$SMPROGRAMS\CityBinder\CityBinder.lnk" "$INSTDIR\iuplua5.exe" '"$INSTDIR\citybinder.lua"'
  CreateShortCut "$INSTDIR\CityBinder.lnk" "$INSTDIR\iuplua5.exe" '"$INSTDIR\citybinder.lua"'
SectionEnd

Section /o "Add CityBinder shortcut to desktop"
  CreateShortCut "$DESKTOP\CityBinder.lnk" "$INSTDIR\iuplua5.exe" '"$INSTDIR\citybinder.lua"'
SectionEnd

;--------------------------------
